// MPU6000 I2C address
#define mpu_I2C_ADDR 0xD2
// MPU6000 Register map
#define    mpu_rm_SELF_TEST_X       0x0D
#define    mpu_rm_SELF_TEST_Y       0x0E
#define    mpu_rm_SELF_TEST_Z       0x0F
#define    mpu_rm_SELF_TEST_A       0x10
#define    mpu_rm_SMPLRT_DIV        0x19
#define    mpu_rm_CONFIG            0x1A
#define    mpu_rm_GYRO_CONFIG       0x1B
#define    mpu_rm_ACCEL_CONFIG      0x1C
#define    mpu_rm_MOT_THR           0x1F
#define    mpu_rm_FIFO_EN           0x23
#define    mpu_rm_I2C_MST_CTRL      0x24
#define    mpu_rm_I2C_SLV0_ADDR     0x25
#define    mpu_rm_I2C_SLV0_REG      0x26
#define    mpu_rm_I2C_SLV0_CTRL     0x27
#define    mpu_rm_I2C_SLV1_ADDR     0x28
#define    mpu_rm_I2C_SLV1_REG      0x29
#define    mpu_rm_I2C_SLV1_CTRL     0x2A
#define    mpu_rm_I2C_SLV2_ADDR     0x2B
#define    mpu_rm_I2C_SLV2_REG      0x2C
#define    mpu_rm_I2C_SLV2_CTRL     0x2D
#define    mpu_rm_I2C_SLV3_ADDR     0x2E
#define    mpu_rm_I2C_SLV3_REG      0x2F
#define    mpu_rm_I2C_SLV3_CTRL     0x30
#define    mpu_rm_I2C_SLV4_ADDR     0x31
#define    mpu_rm_I2C_SLV4_REG      0x32
#define    mpu_rm_I2C_SLV4_DO       0x33
#define    mpu_rm_I2C_SLV4_CTRL     0x34
#define    mpu_rm_I2C_SLV4_DI       0x35
#define    mpu_rm_I2C_MST_STATUS    0x36
#define    mpu_rm_INT_PIN_CFG       0x37
#define    mpu_rm_INT_ENABLE        0x38
#define    mpu_rm_INT_STATUS        0x3A
#define    mpu_rm_raw_accel         0x3B
#define    mpu_rm_ACCEL_XOUT_H      0x3B
#define    mpu_rm_ACCEL_XOUT_L      0x3C
#define    mpu_rm_ACCEL_YOUT_H      0x3D
#define    mpu_rm_ACCEL_YOUT_L      0x3E
#define    mpu_rm_ACCEL_ZOUT_H      0x3F
#define    mpu_rm_ACCEL_ZOUT_L      0x40
#define    mpu_rm_TEMP_OUT_H        0x41
#define    mpu_rm_TEMP_OUT_L        0x42
#define    mpu_rm_raw_gyro          0x43
#define    mpu_rm_GYRO_XOUT_H       0x43
#define    mpu_rm_GYRO_XOUT_L       0x44
#define    mpu_rm_GYRO_YOUT_H       0x45
#define    mpu_rm_GYRO_YOUT_L       0x46
#define    mpu_rm_GYRO_ZOUT_H       0x47
#define    mpu_rm_GYRO_ZOUT_L       0x48
#define    mpu_rm_EXT_SENS_DATA_00  0x49
#define    mpu_rm_EXT_SENS_DATA_01  0x4A
#define    mpu_rm_EXT_SENS_DATA_02  0x4B
#define    mpu_rm_EXT_SENS_DATA_03  0x4C
#define    mpu_rm_EXT_SENS_DATA_04  0x4D
#define    mpu_rm_EXT_SENS_DATA_05  0x4E
#define    mpu_rm_EXT_SENS_DATA_06  0x4F
#define    mpu_rm_EXT_SENS_DATA_07  0x50
#define    mpu_rm_EXT_SENS_DATA_08  0x51
#define    mpu_rm_EXT_SENS_DATA_11  0x54
#define    mpu_rm_EXT_SENS_DATA_09  0x52
#define    mpu_rm_EXT_SENS_DATA_10  0x53
#define    mpu_rm_EXT_SENS_DATA_12  0x55
#define    mpu_rm_EXT_SENS_DATA_13  0x56
#define    mpu_rm_EXT_SENS_DATA_14  0x57
#define    mpu_rm_EXT_SENS_DATA_15  0x58
#define    mpu_rm_EXT_SENS_DATA_16  0x59
#define    mpu_rm_EXT_SENS_DATA_17  0x5A
#define    mpu_rm_EXT_SENS_DATA_18  0x5B
#define    mpu_rm_EXT_SENS_DATA_19  0x5C
#define    mpu_rm_EXT_SENS_DATA_20  0x5D
#define    mpu_rm_EXT_SENS_DATA_21  0x5E
#define    mpu_rm_EXT_SENS_DATA_22  0x5F
#define    mpu_rm_EXT_SENS_DATA_23  0x60
#define    mpu_rm_I2C_SLV0_DO       0x63
#define    mpu_rm_I2C_SLV1_DO       0x64
#define    mpu_rm_I2C_SLV2_DO       0x65
#define    mpu_rm_I2C_SLV3_DO       0x66
#define    mpu_rm_I2C_MST_DELAY_CT  0x67
#define    mpu_rm_SIGNAL_PATH_RES   0x68
#define    mpu_rm_MOT_DETECT_CTRL   0x69
#define    mpu_rm_USER_CTRL         0x6A
#define    mpu_rm_PWR_MGMT_1        0x6B
#define    mpu_rm_PWR_MGMT_2        0x6C
#define    mpu_rm_FIFO_COUNTH       0x72
#define    mpu_rm_FIFO_COUNTL       0x73
#define    mpu_rm_FIFO_R_W          0x74
#define    mpu_rm_WHO_AM_I          0x75

// Compass Register map
#define compass_CRA_REG_M 0x00
#define compass_CRB_REG_M 0x01
#define compass_MR_REG_M  0x02
#define compass_SR_REG_M  0x09
#define compass_IRA_REG_M 0x0A
#define compass_IRB_REG_M 0x0B
#define compass_IRC_REG_M 0x0C
#define compass_OUT_X_H_M 0x03
#define compass_OUT_X_L_M 0x04
#define compass_OUT_Z_H_M 0x05
#define compass_OUT_Z_L_M 0x06
#define compass_OUT_Y_H_M 0x07
#define compass_OUT_Y_L_M 0x08