#include "MPU_IMU_VTFT_v001_objects.h"
#include "MPU_IMU_VTFT_v001_resources.h"

//--------------------- User code ---------------------//

extern char i, buff, gyro_x_out[15], gyro_y_out[15], gyro_z_out[15], accel_x_out[15], accel_y_out[15], accel_z_out[15], temp_out[15];
extern float temp, gyro_x, gyro_y, gyro_z, accel_x, accel_y, accel_z;

// void display_MPU_data(float accel_x,float accel_y, float accel_y,float gyro_x , float gyro_y,float gyro_y){

void display_MPU_data(){
  char stn_out[100] = "0";
  int center=0, x=0 ,y=0, range_c3=0;
  const float max_range = 3.0;
  const float  amplifier = 3.0;    // for bigger amplitude on screen

  float accel_x_intern_float;
  float accel_y_intern_float;
  
  accel_x_intern_float = accel_x * amplifier;
  accel_y_intern_float = accel_y * amplifier;

  // Motor 1 & 2 == Basisachse   == X Achse
  /// Circle X Berechnung////////////////////////////////////////////////
  center = Circle1.Left + Circle1.Radius;                                                // calculating center of hole circle
  if (accel_x <= max_range && accel_x >= -max_range){                                    // smaller max_range, bigger equal 0   -- Positiv , d.h. blase goes right
      range_c3 = (Circle1.Left + 2*Circle1.Radius - 2*Circle2.Radius)- Circle1.Left;     // des Durchmessers/Verfahrweges anhand der Pixel abh?ngig von den Radien der Kreise
      x = (int) (0.5* ((float)range_c3/ max_range) * accel_x_intern_float);
      Circle2.Left = center + x -Circle2.Radius;
       }
       
  if (accel_x > max_range)
     Circle2.Left =  center + Circle1.Radius - Circle2.Radius;

  if (accel_x < -max_range)
     Circle2.Left =  center - Circle1.Radius - Circle2.Radius;

  // Motor 1 & 2  == Achse 2  == Y Achse
  /// Circle Y Berechnung////////////////////////////////////////////////

  center = Circle1.Top + Circle1.Radius;                                                 // Berechnung Mittelpunkt des gesamtetn Kreises
  if (accel_y <= max_range && accel_y >= -max_range){                                    // Kleiner max_range, groesser gleich 0   -- Positiv , d.h. blase wandert nach unten, Negativ d.h. blase wandert nach oben
      range_c3 = (Circle1.Top + 2*Circle1.Radius - 2*Circle2.Radius)- Circle1.Top;       //  Berechung des Durchmessers/Verfahrweges anhand der Pixel abh?ngig von den Radien der Kreise
      y = (int) (0.5* ((float)range_c3/ max_range) * accel_y_intern_float) * (-1);
      Circle2.Top =  center - y -Circle2.Radius;
      }
      
  if (accel_y > max_range)
     Circle2.Top =  center + Circle1.Radius - Circle2.Radius;

  if (accel_y < -max_range)
     Circle2.Top =  center - Circle1.Radius - Circle2.Radius;


  DrawBox(&Box_Clear_Libelle);
  DrawCircle(&Circle1);
  DrawCircle(&Circle2);
  DrawLine(&Line_BasisX);
  DrawLine(&Line_Y);
  
  DrawBox(&Box_Accel);
  strcpy(Label_Accel_X.Caption, accel_x_out);
  DrawLabel(&Label_Accel_X);
  strcpy(Label_Accel_Y.Caption, accel_y_out);
  DrawLabel(&Label_Accel_Y);
  strcpy(Label_Accel_Z.Caption, accel_z_out);
  DrawLabel(&Label_Accel_Z);

  DrawBox(&Box_Gyro);
  strcpy(Label_Gyr_X.Caption, gyro_X_out);
  DrawLabel(&Label_Gyr_X);
  strcpy(Label_Gyr_Y.Caption, gyro_Y_out);
  DrawLabel(&Label_Gyr_Y);
  strcpy(Label_Gyr_Z.Caption, gyro_z_out);
  DrawLabel(&Label_Gyr_Z);

  WDTCONSET = 0x01;

}




//----------------- End of User code ------------------//

// Event Handlers