#line 1 "C:/Users/Alexander Wolf/Documents/PROJEKTE/104 QuadCop/Programming PIC/MPU IMO TFT/MPU_IMU_VTFT_v001_Code/mikroC PRO for PIC32/MPU_IMU_VTFT_v001_events_code.c"
#line 1 "c:/users/alexander wolf/documents/projekte/104 quadcop/programming pic/mpu imo tft/mpu_imu_vtft_v001_code/mikroc pro for pic32/mpu_imu_vtft_v001_objects.h"
typedef struct Screen TScreen;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Circle {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircle;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

typedef struct Line {
 TScreen* OwnerScreen;
 char Order;
 unsigned int First_Point_X;
 unsigned int First_Point_Y;
 unsigned int Second_Point_X;
 unsigned int Second_Point_Y;
 char Pen_Width;
 char Visible;
 unsigned int Color;
} TLine;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CirclesCount;
 TCircle * const code *Circles;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
 unsigned int LinesCount;
 TLine * const code *Lines;
};

extern TScreen Screen1;
extern TBox Box_Clear_Libelle;
extern TBox Box_Accel;
extern TBox Box_Gyro;
extern TCircle Circle1;
extern TCircle Circle2;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TLabel Label4;
extern TLabel Label5;
extern TLabel Label6;
extern TLabel Label7;
extern TLabel Label8;
extern TLine Line_BasisX;
extern TLine Line_Y;
extern TLabel Label_Accel_X;
extern TLabel Label_Accel_Y;
extern TLabel Label_Accel_Z;
extern TLabel Label_Gyr_X;
extern TLabel Label_Gyr_Y;
extern TLabel Label_Gyr_Z;
extern TLabel Label9;
extern TLabel Label10;
extern TLabel * const code Screen1_Labels[16];
extern TCircle * const code Screen1_Circles[2];
extern TBox * const code Screen1_Boxes[3];
extern TLine * const code Screen1_Lines[2];








extern char Box_Clear_Libelle_Caption[];
extern char Box_Accel_Caption[];
extern char Box_Gyro_Caption[];
extern char Circle1_Caption[];
extern char Circle2_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Line_BasisX_Caption[];
extern char Line_Y_Caption[];
extern char Label_Accel_X_Caption[];
extern char Label_Accel_Y_Caption[];
extern char Label_Accel_Z_Caption[];
extern char Label_Gyr_X_Caption[];
extern char Label_Gyr_Y_Caption[];
extern char Label_Gyr_Z_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void DrawBox(TBox *ABox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
#line 1 "c:/users/alexander wolf/documents/projekte/104 quadcop/programming pic/mpu imo tft/mpu_imu_vtft_v001_code/mikroc pro for pic32/mpu_imu_vtft_v001_resources.h"
const code char Tahoma16x19_Regular[];
const code char Tahoma19x19_Bold[];
#line 6 "C:/Users/Alexander Wolf/Documents/PROJEKTE/104 QuadCop/Programming PIC/MPU IMO TFT/MPU_IMU_VTFT_v001_Code/mikroC PRO for PIC32/MPU_IMU_VTFT_v001_events_code.c"
extern char i, buff, gyro_x_out[15], gyro_y_out[15], gyro_z_out[15], accel_x_out[15], accel_y_out[15], accel_z_out[15], temp_out[15];
extern float temp, gyro_x, gyro_y, gyro_z, accel_x, accel_y, accel_z;



void display_MPU_data(){
 char stn_out[100] = "0";
 int center=0, x=0 ,y=0, range_c3=0;
 const float max_range = 3.0;
 const float amplifier = 3.0;

 float accel_x_intern_float;
 float accel_y_intern_float;

 accel_x_intern_float = accel_x * amplifier;
 accel_y_intern_float = accel_y * amplifier;



 center = Circle1.Left + Circle1.Radius;
 if (accel_x <= max_range && accel_x >= -max_range){
 range_c3 = (Circle1.Left + 2*Circle1.Radius - 2*Circle2.Radius)- Circle1.Left;
 x = (int) (0.5* ((float)range_c3/ max_range) * accel_x_intern_float);
 Circle2.Left = center + x -Circle2.Radius;
 }

 if (accel_x > max_range)
 Circle2.Left = center + Circle1.Radius - Circle2.Radius;

 if (accel_x < -max_range)
 Circle2.Left = center - Circle1.Radius - Circle2.Radius;




 center = Circle1.Top + Circle1.Radius;
 if (accel_y <= max_range && accel_y >= -max_range){
 range_c3 = (Circle1.Top + 2*Circle1.Radius - 2*Circle2.Radius)- Circle1.Top;
 y = (int) (0.5* ((float)range_c3/ max_range) * accel_y_intern_float) * (-1);
 Circle2.Top = center - y -Circle2.Radius;
 }

 if (accel_y > max_range)
 Circle2.Top = center + Circle1.Radius - Circle2.Radius;

 if (accel_y < -max_range)
 Circle2.Top = center - Circle1.Radius - Circle2.Radius;


 DrawBox(&Box_Clear_Libelle);
 DrawCircle(&Circle1);
 DrawCircle(&Circle2);
 DrawLine(&Line_BasisX);
 DrawLine(&Line_Y);

 DrawBox(&Box_Accel);
 strcpy(Label_Accel_X.Caption, accel_x_out);
 DrawLabel(&Label_Accel_X);
 strcpy(Label_Accel_Y.Caption, accel_y_out);
 DrawLabel(&Label_Accel_Y);
 strcpy(Label_Accel_Z.Caption, accel_z_out);
 DrawLabel(&Label_Accel_Z);

 DrawBox(&Box_Gyro);
 strcpy(Label_Gyr_X.Caption, gyro_X_out);
 DrawLabel(&Label_Gyr_X);
 strcpy(Label_Gyr_Y.Caption, gyro_Y_out);
 DrawLabel(&Label_Gyr_Y);
 strcpy(Label_Gyr_Z.Caption, gyro_z_out);
 DrawLabel(&Label_Gyr_Z);

 WDTCONSET = 0x01;

}
