/*
 * Project name:
     MPU_IMU_VTFT_v001.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     05.12.2014
 * Time of creation
     11:20:51
 * Test configuration:
     MCU:             P32MX795F512L
     Dev.Board:       EasyPIC_Fusion_v7_for_PIC32
                      http://www.mikroe.com/easypic-fusion/
     Oscillator:      80000000 Hz
     SW:              mikroC PRO for PIC32
                      http://www.mikroe.com/mikroc/pic32/
 */

#include "MPU_IMU_VTFT_v001_objects.h"

extern sfr sbit INT_Direction;

void Init_MPU();
void Print_Readings_UART();
void Process_MPU_Data();
void display_MPU_data();

void main() {
  AD1PCFG = 0xFFFF;                          // Configure AN pins as digital I/O

  // Set PORTC as output
  TRISC = 0;
  TRISE = 0;

  // Set IN pin as input
  INT_Direction = 1;

  // Initialize I2C module
  I2C2_Init(400000);
  Delay_ms(100);

  // Initialize UART module
  UART2_Init(115200);
  Delay_ms(100);
  UART2_write_text("uController started\x0D");


  Init_MPU();                    // Initialize MPU
  
  Start_TP();

  while (1) {
    //Check_TP();
   Process_MPU_Data();
   Print_Readings_UART();
   display_MPU_data();
  }
}
