typedef struct Screen TScreen;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct  Circle {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Radius;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCircle;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

typedef struct  Line {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  First_Point_X;
  unsigned int  First_Point_Y;
  unsigned int  Second_Point_X;
  unsigned int  Second_Point_Y;
  char          Pen_Width;
  char          Visible;
  unsigned int  Color;
} TLine;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned int           ObjectsCount;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           CirclesCount;
  TCircle                * const code *Circles;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
  unsigned int           LinesCount;
  TLine                  * const code *Lines;
};

extern   TScreen                Screen1;
extern   TBox                   Box_Clear_Libelle;
extern   TBox                   Box_Accel;
extern   TBox                   Box_Gyro;
extern   TCircle                Circle1;
extern   TCircle                Circle2;
extern   TLabel                 Label1;
extern   TLabel                 Label2;
extern   TLabel                 Label3;
extern   TLabel                 Label4;
extern   TLabel                 Label5;
extern   TLabel                 Label6;
extern   TLabel                 Label7;
extern   TLabel                 Label8;
extern   TLine                  Line_BasisX;
extern   TLine                  Line_Y;
extern   TLabel                 Label_Accel_X;
extern   TLabel                 Label_Accel_Y;
extern   TLabel                 Label_Accel_Z;
extern   TLabel                 Label_Gyr_X;
extern   TLabel                 Label_Gyr_Y;
extern   TLabel                 Label_Gyr_Z;
extern   TLabel                 Label9;
extern   TLabel                 Label10;
extern   TLabel                 * const code Screen1_Labels[16];
extern   TCircle                * const code Screen1_Circles[2];
extern   TBox                   * const code Screen1_Boxes[3];
extern   TLine                  * const code Screen1_Lines[2];


/////////////////////////
// Events Code Declarations
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Box_Clear_Libelle_Caption[];
extern char Box_Accel_Caption[];
extern char Box_Gyro_Caption[];
extern char Circle1_Caption[];
extern char Circle2_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Line_BasisX_Caption[];
extern char Line_Y_Caption[];
extern char Label_Accel_X_Caption[];
extern char Label_Accel_Y_Caption[];
extern char Label_Accel_Z_Caption[];
extern char Label_Gyr_X_Caption[];
extern char Label_Gyr_Y_Caption[];
extern char Label_Gyr_Z_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void DrawBox(TBox *ABox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
